Sound.init()
white = Color.new(255,255,255)
black = Color.new(0,0,0)
menu_color = Color.new(0,0,0)
selected_color = Color.new(255,0,0)
selected_item = Color.new(0,0,200,50)
oldpad = Controls.read()
bg = Screen.loadImage(System.currentDirectory().."/bg.bmp")
function DiscardDir(files)
	res = {}
	for i, file in pairs(files) do
		if not file.directory then
			table.insert(res,file)
		end
	end
	return res
end
audio_table = DiscardDir(System.listDirectory("/MUSIC/"))
p = 1
menu = {}
current_wav = nil
wav_name = "No file opened"
master_index = 0
MAX_RAM_ALLOCATION = 10485760
function FormatTime(seconds)
	minute = math.floor(seconds/60)
	seconds = seconds%60
	hours = math.floor(minute/60)
	minute = minute%60
	if minute < 10 then
		minute = "0"..minute
	end
	if seconds < 10 then
		seconds = "0"..seconds
	end
	if hours == 0 then
		return minute..":"..seconds
	else
		return hours..":"..minute..":"..seconds
	end
end
function CropPrint(x, y, text, color, screen)
	if string.len(text) > 28 then
		Screen.debugPrint(x, y, string.sub(text,1,28) .. "...", color, screen)
	else
		Screen.debugPrint(x, y, text, color, screen)
	end
end
while true do
	base_y = 0
	i = 0
	while (i <= #audio_table) do
		menu[i] = black
		i = i + 1
	end
	menu[p] = Color.new(255,0,0)
	i = 0
	Screen.waitVblankStart()
	Screen.refresh()
	Screen.drawImage(0,0,bg,TOP_SCREEN)
	Screen.fillRect(0,319,0,239,white,BOTTOM_SCREEN)
	Screen.fillEmptyRect(30,370,15,215,black,TOP_SCREEN)
	Screen.fillRect(31,369,16,214,white,TOP_SCREEN)
	CropPrint(33,18,"File: " .. wav_name,black,TOP_SCREEN)
	if (current_wav ~= nil) then
		Sound.updateStream(current_wav)
		CropPrint(33,33,"Title: " .. Sound.getTitle(current_wav),black,TOP_SCREEN)
		CropPrint(33,48,"Author: " .. Sound.getAuthor(current_wav),black,TOP_SCREEN)
		Screen.debugPrint(33,63,"Time: " ..FormatTime(Sound.getTime(current_wav)).." / "..FormatTime(Sound.getTotalTime(current_wav)),black,TOP_SCREEN)
		Screen.debugPrint(33,78,"Samplerate: "..Sound.getSrate(current_wav),black,TOP_SCREEN)
		if Sound.getType(current_wav) == 1 then
			stype = "Mono"
		else
			stype = "Stereo"
		end
		Screen.debugPrint(33,93,"Audiotype: "..stype,black,TOP_SCREEN)
	end
	for l, file in pairs(audio_table) do
		if (base_y > 226) then
			break
		end
		if (l >= master_index) and not file.directory then
			if (l==p) then
				base_y2 = base_y
				if (base_y) == 0 then
					base_y = 2
				end
				Screen.fillRect(0,319,base_y-2,base_y2+12,selected_item,BOTTOM_SCREEN)
				color = selected_color
				if (base_y) == 2 then
					base_y = 0
				end
			else
				color = menu_color
			end
			CropPrint(0,base_y,file.name,color,BOTTOM_SCREEN)
			base_y = base_y + 15
		end
	end
	Screen.debugPrint(0,0,"3DSurfer v.1.0",white,TOP_SCREEN)
	Controls.init()
	pad = Controls.read()
	if (Controls.check(pad,KEY_DUP)) and not (Controls.check(oldpad,KEY_DUP)) then
		p = p - 1
		if (p >= 16) then
			master_index = p - 15
		end
	elseif (Controls.check(pad,KEY_DDOWN)) and not (Controls.check(oldpad,KEY_DDOWN)) then
		p = p + 1
		if (p >= 17) then
			master_index = p - 15
		end
	end
	if (p < 1) then
		p = #audio_table
		if (p >= 17) then
			master_index = p - 15
		end
	elseif (p > #audio_table) then
		master_index = 0
		p = 1
	end
	if (Controls.check(pad,KEY_A)) and not (Controls.check(oldpad,KEY_A)) then
		if (current_wav ~= nil) then
			if Sound.isPlaying(current_wav) then
				Sound.pause(current_wav)
			end
			Sound.closeWav(current_wav)
		end
		mem_size = audio_table[p].size
		mem_blocks = 2
		wav_name = audio_table[p].name
		while (mem_size * 2) > MAX_RAM_ALLOCATION do
			mem_blocks = mem_blocks + 2
			mem_size = mem_size / 2
		end
		current_wav = Sound.openWav("/MUSIC/"..audio_table[p].name,mem_blocks)
		Sound.play(current_wav,NO_LOOP,0x08,0x09)
	elseif (Controls.check(pad,KEY_B)) and not (Controls.check(oldpad,KEY_B)) then
		if (current_wav ~= nil) then
			if Sound.isPlaying(current_wav) then
				Sound.pause(current_wav)
			else
				Sound.resume(current_wav)
			end
		end
	elseif (Controls.check(pad,KEY_START)) then
		if (current_wav ~= nil) then
			if Sound.isPlaying(current_wav) then
				Sound.pause(current_wav)
			end
			Sound.closeWav(current_wav)
		end
		Screen.freeImage(bg)
		Sound.term()
		System.exit()
	end
	Screen.flip()
	oldpad = pad
end